var obj = {
  name: 'AO',
  summary: 'Awesome Oscillator'
}

obj.info = function () {
  obj._aoCurve = {
    title: 'AO',
    style: Spock.LineCurveStyle.Columns,
    lineWidth: 1,
    hasPerBarColor: true
  }
  obj.curves = [obj._aoCurve]

  obj._slowPeriods = {
    name: 'Slow SMA periods',
    defaultValue: 34
  }

  obj._fastPeriods = {
    name: 'Fast SMA periods',
    defaultValue: 5
  }

  obj._increasingColor = {
    name: 'Increasing color',
    defaultValue: 'forestgreen',
    type: Spock.ParameterType.Color,
  }

  obj._decreasingColor = {
    name: 'Decreasing color',
    defaultValue: 'crimson',
    type: Spock.ParameterType.Color,
  }

  obj.parameters = [
    obj._slowPeriods,
    obj._fastPeriods,
    obj._increasingColor,
    obj._decreasingColor,
  ]
  obj.requiredSource = Spock.RequiredSource.Bar
}

obj.exec = function (period) {
  if (Plot.barUpdateMode === Spock.BarUpdateMode.AllBars) {
    obj._ao = new Array(obj._slowPeriods.value)
  }

  // assert slowPeriods > fastPeriods
  var medianPrices = Plot.median(period, obj._slowPeriods.value)
  if (medianPrices == null) {
    return
  }

  var fastMa = Plot.sma(medianPrices, obj._fastPeriods.value)
  var slowMa = Plot.sma(medianPrices, obj._slowPeriods.value)

  var ao = fastMa - slowMa
  obj._ao[period] = ao
  var prevAo = obj._ao[period - 1]
  if (prevAo == null)
    return
  if (prevAo < ao)
    return [{ value: ao, color: obj._increasingColor.value }]
  if (prevAo > ao)
    return [{ value: ao, color: obj._decreasingColor.value }]
  // Use previous color if new ao val is not > or < prevAo
  return [{ value: ao, color: obj._aoCurve.output[period - 1].color }]
}
