var obj = {
  name: 'BOP',
  summary: 'Balance of Power',
  description: 'BOP = SMA((Close - Open) / (High - Low))'
}

obj.info = function () {
  obj.curves = [{
    title: 'BOP',
    style: Spock.LineCurveStyle.Line,
  }]

  obj._maPeriods = {
    name: 'SMA periods',
    defaultValue: 14
  }

  obj.parameters = [obj._maPeriods]
  obj.requiredSource = Spock.RequiredSource.Bar
}

obj.exec = function (period) {
  if (Plot.barUpdateMode === Spock.BarUpdateMode.AllBars) {
    obj._rawBop = new Array(obj._maPeriods.value)
  }

  var ohlc = Plot.getOHLC(period)
  var range = ohlc.high - ohlc.low
  obj._rawBop[period] = range !== 0 ? (ohlc.close - ohlc.open) / range : 0
  return period >= obj._maPeriods.value ? [Plot.sma(obj._rawBop, obj._maPeriods.value)] : null
}
