var obj = {
  name: 'InversePair',
  group: 'Other',
}

obj.info = function () {
  obj.curves = [{
    title: 'Inverse',
    type: Spock.CurveType.Bar,
    style: Spock.BarCurveStyle.Candle,
    // TODO(seamus): Remove per-bar-color when candle curve gets color property (it's faster)
    hasPerBarColor: true
  }]

  obj._numerator = {
    name: 'Numerator',
    defaultValue: 1,
    type: Spock.ParameterType.Double
  }

  obj._upColor = {
    name: 'Up color',
    defaultValue: 'royalblue',
    type: Spock.ParameterType.Color,
  }

  obj._upWickColor = {
    name: 'Up wick color',
    defaultValue: 'royalblue',
    type: Spock.ParameterType.Color,
  }

  obj._downColor = {
    name: 'Down color',
    defaultValue: 'crimson',
    type: Spock.ParameterType.Color,
  }

  obj._downWickColor = {
    name: 'Down wick color',
    defaultValue: 'crimson',
    type: Spock.ParameterType.Color,
  }

  obj.parameters = [
    obj._numerator,
    obj._upColor,
    obj._upWickColor,
    obj._downColor,
    obj._downWickColor,
  ]

  obj.requiredSource = Spock.RequiredSource.Bar
}

obj.exec = function (period) {
  var ohlc = Plot.getOHLC(period)
  if (ohlc == null) {
    return
  }

  var inverseOhlc = {
    open: obj._numerator.value / ohlc.open,
    high: obj._numerator.value / ohlc.low,
    low: obj._numerator.value / ohlc.high,
    close: obj._numerator.value / ohlc.close
  }

  if (obj._numerator.value < 0) {
    inverseOhlc.low = [inverseOhlc.high, inverseOhlc.high = inverseOhlc.low][0]
  }

  var isUp = inverseOhlc.close >= inverseOhlc.open
  return [{
    value: inverseOhlc,
    color: isUp ? obj._upColor.value : obj._downColor.value,
    wickColor: isUp ? obj._upWickColor.value : obj._downWickColor.value
  }]
}
