var obj = {
  name: 'MA Multiplier',
  summary: 'Multiply MA by a factor',
  description: `Multiply MA by a factor.
 MA type parameter must have a value of 0 for SMA,
 other MA types are not supported.`
}

obj.info = function () {
  obj.overlay = true

  obj._maCurve = {
    title: 'Multiple',
    color: 'red',
    lineWidth: 2
  }

  obj.curves = [obj._maCurve]

  obj._maPeriods = {
    name: 'MA periods',
    defaultValue: 70
  }

  obj._maType = {
    name: 'MA type',
    defaultValue: 0,
  }

  obj._mFactor = {
    name: 'Factor',
    defaultValue: 2.0,
    type: Spock.ParameterType.Double
  }

  obj.parameters = [obj._maPeriods, obj._maType, obj._mFactor]
  obj.requiredSource = Spock.RequiredSource.Tick
}

const MaType = Object.freeze({ SMA: 0 })

// Copied from MaCloud.js
obj._buildCurveTitle = function (maType, maPeriods, factor) {
  let maTypeStr;
  switch (maType) {
    case MaType.SMA:
      maTypeStr = 'MA'
      break;
    default:
      break;
  }
  if (maTypeStr) {
    // FIXME(seamus): Localize
    return `${maTypeStr}(${maPeriods})*${factor}`
  }
  // TODO(seamus): Need a way to get list separator character for locale
  return `INVALID_MA_TYPE(${maType};${maPeriods})`
}

obj.preExec = function () {
  obj._maCurve.title = obj._buildCurveTitle(obj._maType.value, obj._maPeriods.value, obj._mFactor.value)
}

obj.exec = function (period) {
  const n = obj._maPeriods.value
  if (period >= n - 1) {
    return [obj._mFactor.value * Plot.sma(Plot.getTicks(period, n), n)]
  }
}
